#!/bin/bash

############################
# zephirlogs.sh
# instructions spécifiques 
# au module ZephirLogs
############################
#    Main
if [ -x /usr/share/eole/FonctionsEoleNg ]; then
. /usr/share/eole/FonctionsEoleNg
else
        echo 'Erreur : FonctionsEoleNg non trouvé'
        exit 1
fi

if [ -x /usr/bin/ParseDico ]; then
. /usr/bin/ParseDico
else
	echo 'Erreur : ParseDico non trouvé'
	exit 1
fi

# Génération du CA pour la connexion rsyslog en TLS

echo "Génération du CA pour rsyslog..."

if [ -e /etc/ssl/private/ca-eole-rsyslog-key.pem ]; then
	echo "Voulez-vous regénerer le CA ? (O/N)"
	read response
	if [ "$response" == "O" -o "$response" == "o" -o "$response" == "oui"  ]; then
		/usr/bin/certtool --template /etc/ssl/eole-ca-template.cnf --generate-privkey --outfile /etc/ssl/private/ca-eole-rsyslog-key.pem --bits 2048 >/dev/null 2>&1

		if [ ! -d /etc/ssl/ca ]; then
			mkdir -p /etc/ssl/ca
		fi

		/usr/bin/certtool --template /etc/ssl/eole-ca-template.cnf --generate-self-signed --load-privkey /etc/ssl/private/ca-eole-rsyslog-key.pem  --outfile /etc/ssl/ca/ca-eole-rsyslog.pem >/dev/null 2>&1

		/bin/chmod 400 /etc/ssl/ca/ca-eole-rsyslog.pem > /dev/null
# Génération du certificat et de la clé

		echo "Génération de la clé..."
		
		/usr/bin/certtool --template /etc/ssl/eole-client-template.cnf --generate-privkey --outfile /etc/ssl/private/$nom_machine-key.pem --bits 2048 >/dev/null 2>&1
		
		echo "Génération de la requête de signature..."
		
		if [ ! -d /etc/ssl/request ]; then
			mkdir -p /etc/ssl/request
		fi
		
		/usr/bin/certtool --template /etc/ssl/eole-client-template.cnf --generate-request --load-privkey /etc/ssl/private/$nom_machine-key.pem --outfile /etc/ssl/request/$nom_machine-rsyslog-request.pem >/dev/null 2>&1
		
		echo "Génération du couple clé/certificat signé..."
		if [ ! -d /etc/ssl/certs ]; then
			mkdir -p /etc/ssl/certs
		fi
		
		/usr/bin/certtool --template /etc/ssl/eole-client-template.cnf --generate-certificate --load-request /etc/ssl/request/$nom_machine-rsyslog-request.pem --outfile /etc/ssl/certs/$nom_machine-rsyslog-cert.pem --load-ca-certificate /etc/ssl/ca/ca-eole-rsyslog.pem --load-ca-privkey /etc/ssl/private/ca-eole-rsyslog-key.pem >/dev/null 2>&1
	
	fi
else
                /usr/bin/certtool --template /etc/ssl/eole-ca-template.cnf --generate-privkey --outfile /etc/ssl/private/ca-eole-rsyslog-key.pem --bits 2048 >/dev/null 2>&1

                if [ ! -d /etc/ssl/ca ]; then
                        mkdir -p /etc/ssl/ca
                fi

                /usr/bin/certtool --template /etc/ssl/eole-ca-template.cnf --generate-self-signed --load-privkey /etc/ssl/private/ca-eole-rsyslog-key.pem  --outfile /etc/ssl/ca/ca-eole-rsyslog.pem >/dev/null 2>&1

                /bin/chmod 400 /etc/ssl/ca/ca-eole-rsyslog.pem > /dev/null
# Génération du certificat et de la clé

                echo "Génération de la clé..."

                /usr/bin/certtool --template /etc/ssl/eole-client-template.cnf --generate-privkey --outfile /etc/ssl/private/$nom_machine-key.pem --bits 2048 >/dev/null 2>&1

                echo "Génération de la requête de signature..."

                if [ ! -d /etc/ssl/request ]; then
                        mkdir -p /etc/ssl/request
                fi

                /usr/bin/certtool --template /etc/ssl/eole-client-template.cnf --generate-request --load-privkey /etc/ssl/private/$nom_machine-key.pem --outfile /etc/ssl/request/$nom_machine-rsyslog-request.pem >/dev/null 2>&1

                echo "Génération du couple clé/certificat signé..."
                if [ ! -d /etc/ssl/certs ]; then
                        mkdir -p /etc/ssl/certs
                fi

                /usr/bin/certtool --template /etc/ssl/eole-client-template.cnf --generate-certificate --load-request /etc/ssl/request/$nom_machine-rsyslog-request.pem --outfile /etc/ssl/certs/$nom_machine-rsyslog-cert.pem --load-ca-certificate /etc/ssl/ca/ca-eole-rsyslog.pem --load-ca-privkey /etc/ssl/private/ca-eole-rsyslog-key.pem >/dev/null 2>&1

fi

# envoye du CA pour signature sur les clients...
echo "Voulez-vous envoyer le CA de rsyslog sur les clients ? (O/N)"
read sendca
if [ "$sendca" == "O" -o "$sendca" == "o" -o "$sendca" == "oui" ]; then
	echo "Merci d'indiquer les adresses ip des clients séparées par des espaces :"
	read ipclient
			for i in $ipclient; do
				if [ -x /usr/bin/scp ]; then
					/usr/bin/ssh root@$i /bin/mkdir -p /etc/ssl/ca/
					/usr/bin/scp -q /etc/ssl/ca/ca-eole-rsyslog.pem root@$i:/etc/ssl/ca/ca-eole-rsyslog.pem
					/usr/bin/scp -q /etc/ssl/private/ca-eole-rsyslog-key.pem root@$i:/etc/ssl/private/ca-eole-rsyslog-key.pem
				else
					EchoRouge "Paquets SSH non trouvé, merci de l'installer avec la commande apt"
				fi
			done
	fi
# test de la presence du serveur d'enregistrement prelude-manager, si oui enregistrement avec mdp
/usr/bin/tcpcheck 2 $adresse_ip_prelude_manager:5553 | grep -q " alive"
if [ $? == "0" ]; then
       EchoVert "Indiquez le mot de passe fourni par prelude-manager :"
       read preludepass
       /usr/bin/prelude-admin register "prelude-lml" "idmef:w" $adresse_ip_prelude_manager --uid 0 --gid 0 --passwd=$preludepass
       echo "Redémarrage de prelude-lml..."
       /usr/sbin/invoke-rc.d prelude-lml restart
else
       EchoRouge "Le serveur d'enregistrement n'est pas lancé sur le module prelude-manager"
fi
